
#ifndef _H_PLUG_UTILS
#define _H_PLUG_UTILS

#include <stdbool.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

void* make_result_val(void* v, int size) {
    void* v2 = malloc(size);
    memcpy(v2, v, size);
    return v2;
}

#define make_result(is_ok, v) ((Result){ \
    .is_ok = (is_ok), \
    .val = make_result_val((v), sizeof((v))) \
})

#define Ok(v) make_result(true, v)
#define Ok(v) make_result(true, v)


typedef struct Result {
    bool is_ok;
    void* val;
} Result;

void* res_unwrap(Result r) {
    if (!r.is_ok) assert(0);
    return r.val;
}


#endif
